vsg: vsg::TransferTask Class Reference

vsg 1.1.9 VulkanSceneGraph library |

Loading...
Searching...
No Matches
Classes | Public Types | Public Member Functions | Public Attributes | Protected Types | Protected Member Functions | Protected Attributes | List of all members
vsg::TransferTask Class Reference

`#include <TransferTask.h>`

Inheritance diagram for vsg::TransferTask:
[legend]
Collaboration diagram for vsg::TransferTask:
[legend]

## Classes
struct | DataToCopy
struct | TransferBlock
struct | TransferResult

## Public Types
enum | TransferMask { TRANSFER_NONE = 0 , TRANSFER_BEFORE_RECORD_TRAVERSAL = 1 << 0 , TRANSFER_AFTER_RECORD_TRAVERSAL = 1 << 1 , TRANSFER_ALL = TRANSFER_BEFORE_RECORD_TRAVERSAL | TRANSFER_AFTER_RECORD_TRAVERSAL }

## Public Member Functions
| TransferTask (Device *in_device, uint32_t numBuffers=3)
virtual TransferResult | transferData (TransferMask transferMask)
| transfer any vsg::Data entries that have been updated to the associated GPU memory.
virtual bool | containsDataToTransfer (TransferMask transferMask) const
void | assign (const ResourceRequirements::DynamicData &dynamicData)
void | assign (const BufferInfoList &bufferInfoList)
void | assign (const ImageInfoList &imageInfoList)
void | assignTransferConsumedCompletedSemaphore (TransferMask transferMask, ref_ptr< Semaphore > semaphore)
Public Member Functions inherited from vsg::Inherit< Object, TransferTask >
| Inherit (Args &&... args)
std::size_t | sizeofObject () const noexcept override
const char * | className () const noexcept override
const std::type_info & | type_info () const noexcept override
bool | is_compatible (const std::type_info &type) const noexcept override
int | compare (const Object &rhs) const override
void | accept (Visitor &visitor) override
void | accept (ConstVisitor &visitor) const override
void | accept (RecordTraversal &visitor) const override
Public Member Functions inherited from vsg::Object
| Object (const Object &object, const CopyOp &copyop={})
Object & | operator= (const Object &)
template<class T>
T * | cast ()
template<class T>
const T * | cast () const
virtual ref_ptr< Object > | clone (const CopyOp &copyop={}) const
virtual void | traverse (Visitor &)
virtual void | traverse (ConstVisitor &) const
virtual void | traverse (RecordTraversal &) const
virtual void | read (Input &input)
virtual void | write (Output &output) const
void | ref () const noexcept
void | unref () const noexcept
void | unref_nodelete () const noexcept
unsigned int | referenceCount () const noexcept
template<typename T>
void | setValue (const std::string &key, const T &value)
void | setValue (const std::string &key, const char *value)
| specialization of setValue to handle passing C strings
template<typename T>
bool | getValue (const std::string &key, T &value) const
| get specified value type, return false if value associated with key is not assigned or is not the correct type
void | setObject (const std::string &key, ref_ptr< Object > object)
| assign an Object associated with key
Object * | getObject (const std::string &key)
| get Object pointer associated with key, return nullptr if no object associated with key has been assigned
const Object * | getObject (const std::string &key) const
| get const Object pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
T * | getObject (const std::string &key)
| get object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const T * | getObject (const std::string &key) const
| get const object pointer of specified type associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< Object > | getRefObject (const std::string &key)
| get ref_ptr<Object> associated with key, return nullptr if no object associated with key has been assigned
ref_ptr< const Object > | getRefObject (const std::string &key) const
| get ref_ptr<const Object> pointer associated with key, return nullptr if no object associated with key has been assigned
template<class T>
ref_ptr< T > | getRefObject (const std::string &key)
| get ref_ptr<T> of specified type associated with key, return nullptr if no object associated with key has been assigned
template<class T>
const ref_ptr< const T > | getRefObject (const std::string &key) const
| get ref_ptr<const T> of specified type associated with key, return nullptr if no object associated with key has been assigned
void | removeObject (const std::string &key)
| remove meta object or value associated with key
Auxiliary * | getOrCreateAuxiliary ()
Auxiliary * | getAuxiliary ()
const Auxiliary * | getAuxiliary () const

## Public Attributes
ref_ptr< Device > | device
ref_ptr< Queue > | transferQueue
VkDeviceSize | minimumStagingBufferSize = 16 * 1024 * 1024
| minimum size to use when allocating staging buffers.
ref_ptr< Instrumentation > | instrumentation
| hook for assigning Instrumentation to enable profiling of record traversal.
Logger::Level | level = Logger::LOGGER_DEBUG
| control for the level of debug infomation emitted by the TransferTask

## Protected Types
using | OffsetBufferInfoMap = std::map<VkDeviceSize, ref_ptr<BufferInfo>>
using | BufferMap = std::map<ref_ptr<Buffer>, OffsetBufferInfoMap>

## Protected Member Functions
TransferResult | _transferData (DataToCopy &dataToCopy)
void | _transferBufferInfos (DataToCopy &dataToCopy, VkCommandBuffer vk_commandBuffer, TransferBlock &frame, VkDeviceSize &offset)
void | _transferImageInfos (DataToCopy &dataToCopy, VkCommandBuffer vk_commandBuffer, TransferBlock &frame, VkDeviceSize &offset)
void | _transferImageInfo (VkCommandBuffer vk_commandBuffer, TransferBlock &frame, VkDeviceSize &offset, ImageInfo &imageInfo)
Protected Member Functions inherited from vsg::Object
virtual void | _attemptDelete () const
void | setAuxiliary (Auxiliary *auxiliary)

## Protected Attributes
std::mutex | _mutex
DataToCopy | _earlyDataToCopy
DataToCopy | _lateDataToCopy
size_t | _bufferCount

## Additional Inherited Members
Static Public Member Functions inherited from vsg::Inherit< Object, TransferTask >
static ref_ptr< TransferTask > | create (Args &&... args)
static ref_ptr< TransferTask > | create_if (bool flag, Args &&... args)
Static Public Member Functions inherited from vsg::Object
static ref_ptr< Object > | create ()
static ref_ptr< Object > | create_if (bool flag)
static void * | operator new (std::size_t count)
| provide new and delete to enable custom memory management via the vsg::Allocator singleton, using the MEMORY_AFFINTY_OBJECTS
static void | operator delete (void *ptr)

## Detailed Description

TransferTask manages a collection of dynamically updated vsg::Data associated with GPU memory of vsg::BufferInfo and vsg::ImageInfo. During the viewer.compile(..) traversal the collection of dynamic data that has dataVariance of DYNAMIC_DATA* is assigned to the appropriate TransferTask and then each new frame that collection of data is checked to see if the modification count has changed, if it has that data is copied to the associated BufferInfo/ImageInfo. vsg::Data that are orphaned so the TransferTask has the only remaining reference to them are automatically removed.

The documentation for this class was generated from the following file:

- include/vsg/app/TransferTask.h